#include <iostream>
#include <cstdint>
#include <valarray>
#include <tuple>

void test1() {
    using ratios_t = std::valarray<float>;

    ratios_t a{0.5, 1, 2};
    auto res ( ratios_t::value_type(256) / a );
    std::cout << "Test1: ";
    for(auto const& r : ratios_t{res})
        std::cout << r << " ";
    std::cout << std::endl;
}

void test2() {
    using scales_t = std::valarray<std::uint32_t>;

    auto w = 23.f;
    auto h = 12.f;
    scales_t scales{8, 16, 32};

    auto const ws( (scales_t::value_type)w * scales );
    auto const hs( (scales_t::value_type)h * scales );
    std::cout << "Test2: " << std::endl;
    std::cout << "widths: ";
    for(auto const& w : scales_t{ws}) {
        std::cout << w << " ";
    }
    std::cout << std::endl;
    std::cout << "heights: ";
    for(auto const& h : scales_t{hs}) {
        std::cout << h << " ";
    }
    std::cout << std::endl;
}

int main() {
    test1();
    test2();
    return 0;
}